/***********************************************************************

  consoleFcns.h - Header file for consoleFcns.c

  author    John Madsen
  revision  1.0
  date      2022-07-25



  history   1.0 initial release

***********************************************************************/
#pragma once



/***********************************************************************

		Defines

***********************************************************************/

#define STRING_OK	0
#define NO_INPUT 	1
#define TOO_LONG 	2

#define PROMPT_STR "FortisKap"


/* Console command history can be stored to and loaded from a file.
 * The easiest way to do this is to use FATFS filesystem on top of
 * wear_levelling library.
 */
#define MOUNT_PATH "/data"
#define HISTORY_PATH MOUNT_PATH "/history.txt"
#define CONFIG_CONSOLE_MAX_COMMAND_LINE_LENGTH 1024



/*******************************************************************

		Structure/Enum Definitions

 *******************************************************************/




/***********************************************************************

		Function Prototypes

***********************************************************************/

// initialize console & commands
void consoleInit(void);

// initialize console & commands - try to keep from blocking until terminal started on PC
void consoleRunInit(void);

// initialize USB Serial interface
//void consoleUSBSerialInit(void);

void consoleConnectCheck(void);






